#! /bin/sh

initdir=`pwd`
pref=""
suf=""
newdir="."
plant="NO"
seeing_o="1.0"

while [ $# -gt 0 ]; do
  case "$1" in
  -d)
    shift
    newdir=$1
    shift
    ;;
  -p)
    shift
    pref=$1
    shift
    ;;
  -s)
    shift
    suf=$1
    shift
    ;;
  -f)
    shift
    seeing_o=$1
    shift
    ;;
  -h|-?)
    echo "Usage: initfind.sh [-d directory] [-p prefix] [-s suffix] [-f seeing] [-h|-?]"
    exit
    ;;
  esac
done

cd $newdir
basedir=`pwd`
tailbin=`which tail`
ln -s ${tailbin} initfind.tail
\rm $basedir/find.input
touch $basedir/find.input

initfind.tail -n +1 -f $basedir/directory | (
  while read wd; do
    if [ X"$wd" = XDONE ]; then
      pid=`pidof -o $$ -o $PPID -o %PPID -x initfind.tail`
      if [ "$pid" != "" ] ; then
        \rm -f initfind.tail
	kill $pid
	exit
      fi
    fi
    echo $wd
    cd $wd
    echo "# Files to be planted and searched" > proc-these-files
    echo "#             image  fwhm plant" >> proc-these-files
    for im in $pref*$suf.fits; do
      if [ ! -e ${im/.fits/}.mopheader ]; then
        stepZjmp -f ${im/.fits/}
      fi
      step0jmp -f ${im/.fits/} -w 4.5 -t 4. -m 20000.
      \rm -f ${im/.fits/}.*.psf
      if [ -e ${im/.fits/}.fwhm ]; then
        read seeing_c < ${im/.fits/}.fwhm
	seeing=$seeing_c
      else
        seeing=$seeing_o
      fi
      echo " ${im/.fits/} ${seeing} NO" >> proc-these-files
    done
    cd $basedir
    echo "-p '' -d $wd " >> $basedir/find.input
  done
)

echo "DONE" >> $basedir/find.input

cd $initdir

exit
